<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ServiceRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Service;
use App\ServiceDescriptions;
use App\Forms;
use App\FormDescriptions;
use App\Language;
use App\Module;
use Users_model;

class ServiceController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/services';
    /** View folder */
    private $viewDirectory= 'admin.services.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('services.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the services.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query =Service::orderBy('id', 'ASC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->whereIn('id',servicelangid($request->name));
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $services= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('services'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('services.store');
        $head = metaFields('services', 'add_new', getCurrentLocale()) ?? __('services.new');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','language') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param ServiceRequest $request
     * @return JsonResponse
     */
    public function store(ServiceRequest $request) :JsonResponse
    {
       
        $img=$request->file('img');
        $name=mt_rand(1000000, 9999999).time().'img-'.$img->getClientOriginalExtension();
        $img->move(public_path('/lamis/images/services/'),$name);
        $service= Service::create(['img'=>$name]);
        foreach ($request->service as $key => $row) {
            
            $servicedescription = ServiceDescriptions::create([
                'name'=>$row['name'],
                'description'=>$row['description'],
                'service_id'=>$service['id'],
                'language_id'=>$row['language_id'],
                ]);
                
          
        }
       
                if(isset($request->form)){
           foreach ($request->form as $value) {
               
             $form = Forms::create([
                   'service_id'=>$service['id']
               ]);
               
               foreach($value as $row){ 
                 FormDescriptions::create([
                    'question'=>$row['question'],
                    'language_id'=>$row['lang'],
                    'form_id'=>$form['id'],
                ]);
           }
           }
}

        

        return response()->json(['message'=> __('dashboard.saveDone')]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  service  $service
     * @return View
     */
    public function edit(service $service): View
    {
        $action= route('services.update', $service->id);
        $head = metaFields('service', 'edit', getCurrentLocale()) ?? __('services.edit');
        $language = Language::where('status',1)->get();
        $forms = Forms::where('service_id',$service->id)->get();

        return view( $this->viewDirectory.'form', compact( 'service','forms','action', 'head' ,'language' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  ServiceRequest  $request
     * @param  service  $service
     * @return JsonResponse
     */
    public function update(ServiceRequest $request, Service $service) :JsonResponse
    {
        
         if ($request->hasFile('img')) {
        $img=$request->file('img');
        $name=mt_rand(1000000, 9999999).time().'img-'.$service->id.'.'.$img->getClientOriginalExtension();
        $img->move(public_path('/lamis/images/services/'),$name);
        $service->img=$name;
        $service->save();
         }
        $services = ServiceDescriptions::where('service_id',$service->id)->forceDelete();
        $serviceforms = Forms::where('service_id',$service->id)->get();
        foreach($serviceforms as $data){
        $data->forceDelete();
        }
        foreach ($request->service as $key => $row) {
            
            $servicedescription = ServiceDescriptions::create([
                'name'=>$row['name'],
                'description'=>$row['description'],
                'service_id'=>$service['id'],
                'language_id'=>$row['language_id'],
                ]);
            
        }
         if(isset($request->form)){
           foreach ($request->form as $value) {
               
             $form = Forms::create([
                   'service_id'=>$service['id']
               ]);
               
               foreach($value as $row){ 
                 FormDescriptions::create([
                    'question'=>$row['question'],
                    'language_id'=>$row['lang'],
                    'form_id'=>$form['id'],
                ]);
           }
           }
}

        
        

        return response()->json(['message'=> __('dashboard.saveDone')]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $service = Service::withTrashed()->find($id);
        if ($service) {
            if ($service->deleted_at) {
                $service->forceDelete();
            } else {
                $service->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Service::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Service::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $service = Service::withTrashed()->find($id);

        if ($service){
            $service->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $service = Service::whereIn('id', $request->ids)->onlyTrashed();
        if ($service){
            $service->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
